diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/spectrum-wifi-phy.cc ns-3.34/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.33/src/wifi/model/spectrum-wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/spectrum-wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,13 +26,13 @@
 #include "ns3/log.h"
 #include "ns3/double.h"
 #include "ns3/boolean.h"
-#include "ns3/net-device.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/node.h"
+#include "ns3/simulator.h"
 #include "spectrum-wifi-phy.h"
-#include "wifi-spectrum-signal-parameters.h"
 #include "wifi-spectrum-phy-interface.h"
+#include "wifi-spectrum-signal-parameters.h"
 #include "wifi-utils.h"
-#include "wifi-ppdu.h"
 #include "wifi-psdu.h"
 
 namespace ns3 {
@@ -92,6 +92,9 @@
   NS_LOG_FUNCTION (this);
   m_channel = 0;
   m_wifiSpectrumPhyInterface = 0;
+  m_antenna = 0;
+  m_rxSpectrumModel = 0;
+  m_ruBands.clear ();
   WifiPhy::DoDispose ();
 }
 
@@ -160,17 +163,49 @@
     }
   if (GetPhyStandard () >= WIFI_PHY_STANDARD_80211ax)
     {
-      for (unsigned int type = 0; type < 7; type++)
+      // For a given RU type, some RUs over a channel occupy the same tones as
+      // the corresponding RUs over a subchannel, while some others not. For instance,
+      // the first nine 26-tone RUs over an 80 MHz channel occupy the same tones as
+      // the first nine 26-tone RUs over the lowest 40 MHz subchannel. Therefore, we
+      // need to store all the bands in a set (which removes duplicates) and then
+      // pass the elements in the set to AddBand (to which we cannot pass duplicates)
+      if (m_ruBands[channelWidth].empty ())
         {
-          HeRu::RuType ruType = static_cast <HeRu::RuType> (type);
-          for (std::size_t index = 1; index <= HeRu::GetNRus (channelWidth, ruType); index++)
+          for (uint16_t bw = 160; bw >= 20; bw = bw / 2)
             {
-              HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup (channelWidth, ruType, index);
-              HeRu::SubcarrierRange range = std::make_pair (group.front ().first, group.back ().second);
-              WifiSpectrumBand band = ConvertHeRuSubcarriers (channelWidth, range);
-              m_interference.AddBand (band);
+              for (uint8_t i = 0; i < (channelWidth / bw); ++i)
+                {
+                  for (unsigned int type = 0; type < 7; type++)
+                    {
+                      HeRu::RuType ruType = static_cast <HeRu::RuType> (type);
+                      std::size_t nRus = HeRu::GetNRus (bw, ruType);
+                      for (std::size_t phyIndex = 1; phyIndex <= nRus; phyIndex++)
+                        {
+                          HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup (bw, ruType, phyIndex);
+                          HeRu::SubcarrierRange range = std::make_pair (group.front ().first, group.back ().second);
+                          WifiSpectrumBand band = ConvertHeRuSubcarriers (bw, GetGuardBandwidth (channelWidth),
+                                                                          range, i);
+                          std::size_t index = (bw == 160 && phyIndex > nRus / 2
+                                               ? phyIndex - nRus / 2 : phyIndex);
+                          bool primary80IsLower80 = (GetOperatingChannel ().GetPrimaryChannelIndex (20)
+                                                     < bw / 40);
+                          bool primary80 = (bw < 160
+                                            || ruType == HeRu::RU_2x996_TONE
+                                            || (primary80IsLower80 && phyIndex <= nRus / 2)
+                                            || (!primary80IsLower80 && phyIndex > nRus / 2));
+                          HeRu::RuSpec ru (ruType, index, primary80);
+                          ru.SetPhyIndex (bw, GetOperatingChannel ().GetPrimaryChannelIndex (20));
+                          NS_ABORT_IF (ru.GetPhyIndex () != phyIndex);
+                          m_ruBands[channelWidth].insert ({band, ru});
+                        }
+                    }
+                }
             }
         }
+      for (const auto& bandRuPair : m_ruBands[channelWidth])
+        {
+          m_interference.AddBand (bandRuPair.first);
+        }
     }
 }
 
@@ -286,10 +321,10 @@
           WifiSpectrumBand filteredBand = GetBand (bw, i);
           Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), filteredBand);
           SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for" << bw << " MHz channel band " << +i << ": " << Integral (filteredSignal));
+          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for " << bw << " MHz channel band " << +i << ": " << Integral (filteredSignal));
           double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
           rxPowerW.insert ({filteredBand, rxPowerPerBandW});
-          NS_LOG_DEBUG ("Signal power received after antenna gain for" << bw << " MHz channel band " << +i << ": " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
+          NS_LOG_DEBUG ("Signal power received after antenna gain for " << bw << " MHz channel band " << +i << ": " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
         }
     }
 
@@ -308,21 +343,15 @@
   
   if (GetPhyStandard () >= WIFI_PHY_STANDARD_80211ax)
     {
-      for (unsigned int type = 0; type < 7; type++)
+      NS_ASSERT (!m_ruBands[channelWidth].empty ());
+      for (const auto& bandRuPair : m_ruBands[channelWidth])
         {
-          HeRu::RuType ruType = static_cast <HeRu::RuType> (type);
-          for (std::size_t index = 1; index <= HeRu::GetNRus (channelWidth, ruType); index++)
-            {
-              HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup (channelWidth, ruType, index);
-              HeRu::SubcarrierRange range = std::make_pair (group.front ().first, group.back ().second);
-              WifiSpectrumBand band = ConvertHeRuSubcarriers (channelWidth, range);
-              Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), band);
-              SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
-              NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for RU with type " << ruType << " and range (" << range.first << "; " << range.second << ") -> (" << band.first << "; " << band.second <<  "): " << Integral (filteredSignal));
-              double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
-              NS_LOG_DEBUG ("Signal power received after antenna gain for RU with type " << ruType << " and range (" << range.first << "; " << range.second << ") -> (" << band.first << "; " << band.second <<  "): " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
-              rxPowerW.insert ({band, rxPowerPerBandW});
-            }
+          Ptr<SpectrumValue> filter = WifiSpectrumValueHelper::CreateRfFilter (GetFrequency (), channelWidth, GetBandBandwidth (), GetGuardBandwidth (channelWidth), bandRuPair.first);
+          SpectrumValue filteredSignal = (*filter) * (*receivedSignalPsd);
+          NS_LOG_DEBUG ("Signal power received (watts) before antenna gain for RU with type " << bandRuPair.second.GetRuType () << " and index " << bandRuPair.second.GetIndex () << " -> (" << bandRuPair.first.first << "; " << bandRuPair.first.second <<  "): " << Integral (filteredSignal));
+          double rxPowerPerBandW = Integral (filteredSignal) * DbToRatio (GetRxGain ());
+          NS_LOG_DEBUG ("Signal power received after antenna gain for RU with type " << bandRuPair.second.GetRuType () << " and index " << bandRuPair.second.GetIndex () << " -> (" << bandRuPair.first.first << "; " << bandRuPair.first.second <<  "): " << rxPowerPerBandW << " W (" << WToDbm (rxPowerPerBandW) << " dBm)");
+          rxPowerW.insert ({bandRuPair.first, rxPowerPerBandW});
         }
     }
 
@@ -333,31 +362,61 @@
   // Log the signal arrival to the trace source
   m_signalCb (wifiRxParams ? true : false, senderNodeId, WToDbm (totalRxPowerW), rxDuration);
 
-  // Do no further processing if signal is too weak
-  // Current implementation assumes constant RX power over the PPDU duration
-  if (WToDbm (totalRxPowerW) < GetRxSensitivity ())
-    {
-      NS_LOG_INFO ("Received signal too weak to process: " << WToDbm (totalRxPowerW) << " dBm");
-      return;
-    }
   if (wifiRxParams == 0)
     {
       NS_LOG_INFO ("Received non Wi-Fi signal");
       m_interference.AddForeignSignal (rxDuration, rxPowerW);
-      SwitchMaybeToCcaBusy ();
+      SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (nullptr));
       return;
     }
   if (wifiRxParams && m_disableWifiReception)
     {
       NS_LOG_INFO ("Received Wi-Fi signal but blocked from syncing");
       m_interference.AddForeignSignal (rxDuration, rxPowerW);
-      SwitchMaybeToCcaBusy ();
+      SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (nullptr));
+      return;
+    }
+  // Do no further processing if signal is too weak
+  // Current implementation assumes constant RX power over the PPDU duration
+  // Compare received TX power per MHz to normalized RX sensitivity
+  uint16_t txWidth = wifiRxParams->ppdu->GetTransmissionChannelWidth ();
+  if (totalRxPowerW < DbmToW (GetRxSensitivity ()) * (txWidth / 20.0))
+    {
+      NS_LOG_INFO ("Received signal too weak to process: " << WToDbm (totalRxPowerW) << " dBm");
       return;
     }
 
+  // Unless we are receiving a TB PPDU, do not sync with this signal if the PPDU
+  // does not overlap with the receiver's primary20 channel
+  if (wifiRxParams->txPhy != 0)
+    {
+      Ptr<WifiNetDevice> dev = DynamicCast<WifiNetDevice> (rxParams->txPhy->GetDevice ());
+      NS_ASSERT (dev != 0);
+      Ptr<WifiPhy> txPhy = dev->GetPhy ();
+      NS_ASSERT (txPhy != 0);
+      uint16_t txChannelWidth = wifiRxParams->ppdu->GetTxVector ().GetChannelWidth ();
+      uint16_t txCenterFreq = txPhy->GetOperatingChannel ().GetPrimaryChannelCenterFrequency (txChannelWidth);
+
+      // if the channel width is a multiple of 20 MHz, then we consider the primary20 channel
+      uint16_t width = (GetChannelWidth () % 20 == 0 ? 20 : GetChannelWidth ());
+      uint16_t p20MinFreq =
+          GetOperatingChannel ().GetPrimaryChannelCenterFrequency (width) - width / 2;
+      uint16_t p20MaxFreq =
+          GetOperatingChannel ().GetPrimaryChannelCenterFrequency (width) + width / 2;
+
+      if (!wifiRxParams->ppdu->CanBeReceived (txCenterFreq, p20MinFreq, p20MaxFreq))
+        {
+          NS_LOG_INFO ("Cannot receive the PPDU, consider it as interference");
+          m_interference.Add (wifiRxParams->ppdu, wifiRxParams->ppdu->GetTxVector (),
+                              rxDuration, rxPowerW);
+          SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (wifiRxParams->ppdu));
+          return;
+        }
+    }
+
   NS_LOG_INFO ("Received Wi-Fi signal");
-  Ptr<WifiPpdu> ppdu = Copy (wifiRxParams->ppdu);
-  StartReceivePreamble (ppdu, rxPowerW);
+  Ptr<WifiPpdu> ppdu = wifiRxParams->ppdu->Copy ();
+  StartReceivePreamble (ppdu, rxPowerW, rxDuration);
 }
 
 Ptr<AntennaModel>
@@ -382,72 +441,23 @@
   m_wifiSpectrumPhyInterface->SetDevice (device);
 }
 
-Ptr<SpectrumValue>
-SpectrumWifiPhy::GetTxPowerSpectralDensity (uint16_t centerFrequency, uint16_t channelWidth, double txPowerW, WifiModulationClass modulationClass) const
-{
-  NS_LOG_FUNCTION (centerFrequency << channelWidth << txPowerW);
-  Ptr<SpectrumValue> v;
-  switch (modulationClass)
-    {
-    case WIFI_MOD_CLASS_OFDM:
-    case WIFI_MOD_CLASS_ERP_OFDM:
-      v = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity (centerFrequency, channelWidth, txPowerW, GetGuardBandwidth (channelWidth),
-                                                                     m_txMaskInnerBandMinimumRejection, m_txMaskOuterBandMinimumRejection, m_txMaskOuterBandMaximumRejection);
-      break;
-    case WIFI_MOD_CLASS_DSSS:
-    case WIFI_MOD_CLASS_HR_DSSS:
-      NS_ABORT_MSG_IF (channelWidth != 22, "Invalid channel width for DSSS");
-      v = WifiSpectrumValueHelper::CreateDsssTxPowerSpectralDensity (centerFrequency, txPowerW, GetGuardBandwidth (channelWidth));
-      break;
-    case WIFI_MOD_CLASS_HT:
-    case WIFI_MOD_CLASS_VHT:
-      v = WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity (centerFrequency, channelWidth, txPowerW, GetGuardBandwidth (channelWidth),
-                                                                       m_txMaskInnerBandMinimumRejection, m_txMaskOuterBandMinimumRejection, m_txMaskOuterBandMaximumRejection);
-      break;
-    case WIFI_MOD_CLASS_HE:
-      v = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity (centerFrequency, channelWidth, txPowerW, GetGuardBandwidth (channelWidth),
-                                                                       m_txMaskInnerBandMinimumRejection, m_txMaskOuterBandMinimumRejection, m_txMaskOuterBandMaximumRejection);
-      break;
-    default:
-      NS_FATAL_ERROR ("modulation class unknown: " << modulationClass);
-      break;
-    }
-  return v;
-}
-
-uint16_t
-SpectrumWifiPhy::GetCenterFrequencyForChannelWidth (WifiTxVector txVector) const
+void
+SpectrumWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
 {
-  NS_LOG_FUNCTION (this << txVector);
-  uint16_t centerFrequencyForSupportedWidth = GetFrequency ();
-  uint16_t supportedWidth = GetChannelWidth ();
-  uint16_t currentWidth = txVector.GetChannelWidth ();
-  if (currentWidth != supportedWidth)
-    {
-      uint16_t startingFrequency = centerFrequencyForSupportedWidth - (supportedWidth / 2);
-      return startingFrequency + (currentWidth / 2); // primary channel is in the lower part (for the time being)
-    }
-  return centerFrequencyForSupportedWidth;
+  NS_LOG_FUNCTION (this << ppdu);
+  GetPhyEntity (ppdu->GetModulation ())->StartTx (ppdu);
 }
 
 void
-SpectrumWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
+SpectrumWifiPhy::Transmit (Ptr<WifiSpectrumSignalParameters> txParams)
 {
-  NS_LOG_FUNCTION (this << ppdu);
-  WifiTxVector txVector = ppdu->GetTxVector ();
-  double txPowerDbm = GetTxPowerForTransmission (txVector) + GetTxGain ();
-  NS_LOG_DEBUG ("Start transmission: signal power before antenna gain=" << txPowerDbm << "dBm");
-  double txPowerWatts = DbmToW (txPowerDbm);
-  Ptr<SpectrumValue> txPowerSpectrum = GetTxPowerSpectralDensity (GetCenterFrequencyForChannelWidth (txVector), txVector.GetChannelWidth (), txPowerWatts, ppdu->GetModulation ());
-  Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters> ();
-  txParams->duration = ppdu->GetTxDuration ();
-  txParams->psd = txPowerSpectrum;
+  NS_LOG_FUNCTION (this << txParams);
+
+  //Finish configuration
   NS_ASSERT_MSG (m_wifiSpectrumPhyInterface, "SpectrumPhy() is not set; maybe forgot to call CreateWifiSpectrumPhyInterface?");
   txParams->txPhy = m_wifiSpectrumPhyInterface->GetObject<SpectrumPhy> ();
   txParams->txAntenna = m_antenna;
-  txParams->ppdu = ppdu;
-  NS_LOG_DEBUG ("Starting transmission with power " << WToDbm (txPowerWatts) << " dBm on channel " << +GetChannelNumber ());
-  NS_LOG_DEBUG ("Starting transmission with integrated spectrum power " << WToDbm (Integral (*txPowerSpectrum)) << " dBm; spectrum model Uid: " << txPowerSpectrum->GetSpectrumModel ()->GetUid ());
+
   m_channel->StartTx (txParams);
 }
 
@@ -459,7 +469,6 @@
     {
     case WIFI_PHY_STANDARD_80211a:
     case WIFI_PHY_STANDARD_80211g:
-    case WIFI_PHY_STANDARD_holland:
     case WIFI_PHY_STANDARD_80211b:
     case WIFI_PHY_STANDARD_80211n:
     case WIFI_PHY_STANDARD_80211ac:
@@ -537,12 +546,13 @@
 }
 
 WifiSpectrumBand
-SpectrumWifiPhy::ConvertHeRuSubcarriers (uint16_t channelWidth, HeRu::SubcarrierRange range) const
+SpectrumWifiPhy::ConvertHeRuSubcarriers (uint16_t bandWidth, uint16_t guardBandwidth,
+                                         HeRu::SubcarrierRange range, uint8_t bandIndex) const
 {
   WifiSpectrumBand convertedSubcarriers;
-  uint32_t nGuardBands = static_cast<uint32_t> (((2 * GetGuardBandwidth (channelWidth) * 1e6) / GetBandBandwidth ()) + 0.5);
+  uint32_t nGuardBands = static_cast<uint32_t> (((2 * guardBandwidth * 1e6) / GetBandBandwidth ()) + 0.5);
   uint32_t centerFrequencyIndex = 0;
-  switch (channelWidth)
+  switch (bandWidth)
     {
     case 20:
       centerFrequencyIndex = (nGuardBands / 2) + 6 + 122;
@@ -557,12 +567,24 @@
       centerFrequencyIndex = (nGuardBands / 2) + 12 + 1012;
       break;
     default:
-      NS_FATAL_ERROR ("ChannelWidth " << channelWidth << " unsupported");
+      NS_FATAL_ERROR ("ChannelWidth " << bandWidth << " unsupported");
       break;
     }
+
+  size_t numBandsInBand = static_cast<size_t> (bandWidth * 1e6 / GetBandBandwidth ());
+  centerFrequencyIndex += numBandsInBand * bandIndex;
+
   convertedSubcarriers.first = centerFrequencyIndex + range.first;
   convertedSubcarriers.second = centerFrequencyIndex + range.second;
   return convertedSubcarriers;
 }
 
+std::tuple<double, double, double>
+SpectrumWifiPhy::GetTxMaskRejectionParams (void) const
+{
+  return std::make_tuple (m_txMaskInnerBandMinimumRejection,
+                          m_txMaskOuterBandMinimumRejection,
+                          m_txMaskOuterBandMaximumRejection);
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/spectrum-wifi-phy.h ns-3.34/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.33/src/wifi/model/spectrum-wifi-phy.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/spectrum-wifi-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -29,13 +29,15 @@
 #include "ns3/antenna-model.h"
 #include "ns3/spectrum-channel.h"
 #include "ns3/spectrum-model.h"
-#include "ns3/wifi-spectrum-value-helper.h"
 #include "wifi-phy.h"
+#include <map>
+
+class SpectrumWifiPhyFilterTest;
 
 namespace ns3 {
 
 class WifiSpectrumPhyInterface;
-class WifiPpdu;
+struct WifiSpectrumSignalParameters;
 
 /**
  * \brief 802.11 PHY layer model
@@ -52,6 +54,9 @@
 class SpectrumWifiPhy : public WifiPhy
 {
 public:
+  /// allow SpectrumWifiPhyFilterTest class access
+  friend class ::SpectrumWifiPhyFilterTest;
+
   /**
    * \brief Get the type ID.
    * \return the object TypeId
@@ -62,8 +67,10 @@
   virtual ~SpectrumWifiPhy ();
 
   // Implementation of pure virtual method.
-  void StartTx (Ptr<WifiPpdu> ppdu);
-  Ptr<Channel> GetChannel (void) const;
+  void StartTx (Ptr<WifiPpdu> ppdu) override;
+  Ptr<Channel> GetChannel (void) const override;
+  uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const override;
+  std::tuple<double, double, double> GetTxMaskRejectionParams (void) const override;
 
   /**
    * Set the SpectrumChannel this SpectrumWifiPhy is to be connected to.
@@ -81,16 +88,6 @@
   void StartRx (Ptr<SpectrumSignalParameters> rxParams);
 
   /**
-   * Get the center frequency of the channel corresponding the current TxVector rather than
-   * that of the supported channel width.
-   * Consider that this "primary channel" is on the lower part for the time being.
-   *
-   * \param txVector the TXVECTOR that has the channel width that is to be used
-   * \return the center frequency in MHz corresponding to the channel width to be used
-   */
-  uint16_t GetCenterFrequencyForChannelWidth (WifiTxVector txVector) const;
-
-  /**
    * Method to encapsulate the creation of the WifiSpectrumPhyInterface
    * object (used to bind the WifiSpectrumPhy to a SpectrumChannel) and
    * to link it to this SpectrumWifiPhy instance
@@ -129,19 +126,6 @@
   uint32_t GetBandBandwidth (void) const;
 
   /**
-   * \param currentChannelWidth channel width of the current transmission (MHz)
-   * \return the width of the guard band (MHz)
-   *
-   * Note: in order to properly model out of band transmissions for OFDM, the guard
-   * band has been configured so as to expand the modeled spectrum up to the
-   * outermost referenced point in "Transmit spectrum mask" sections' PSDs of
-   * each PHY specification of 802.11-2016 standard. It thus ultimately corresponds
-   * to the current channel bandwidth (which can be different from devices max
-   * channel width).
-   */
-  uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const;
-
-  /**
    * Callback invoked when the PHY model starts to process a signal
    *
    * \param signalType Whether signal is WiFi (true) or foreign (false)
@@ -153,17 +137,22 @@
 
   // The following four methods call to the base WifiPhy class method
   // but also generate a new SpectrumModel if called during runtime
-  virtual void SetChannelNumber (uint8_t id);
-  virtual void SetFrequency (uint16_t freq);
-  virtual void SetChannelWidth (uint16_t channelwidth);
-  virtual void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band);
-
+  void SetChannelNumber (uint8_t id) override;
+  void SetFrequency (uint16_t freq) override;
+  void SetChannelWidth (uint16_t channelwidth) override;
+  void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band) override;
 
+  /**
+   * This function is sending the signal to the Spectrum channel
+   * after finishing the configuration of the transmit parameters.
+   *
+   * \param txParams the parameters to be provided to the Spectrum channel
+   */
+  void Transmit (Ptr<WifiSpectrumSignalParameters> txParams);
 
 protected:
-  // Inherited
-  void DoDispose (void);
-  void DoInitialize (void);
+  void DoDispose (void) override;
+  void DoInitialize (void) override;
 
   /**
    * Get the start band index and the stop band index for a given band
@@ -173,30 +162,21 @@
    *
    * \return a pair of start and stop indexes that defines the band
    */
-  WifiSpectrumBand GetBand (uint16_t bandWidth, uint8_t bandIndex = 0);
-
+  WifiSpectrumBand GetBand (uint16_t bandWidth, uint8_t bandIndex = 0) override;
 
 private:
   /**
-   * \param centerFrequency center frequency (MHz)
-   * \param channelWidth channel width (MHz) of the channel for the current transmission
-   * \param txPowerW power in W to spread across the bands
-   * \param modulationClass the modulation class
-   * \return Pointer to SpectrumValue
-   *
-   * This is a helper function to create the right TX PSD corresponding
-   * to the standard in use.
-   */
-  Ptr<SpectrumValue> GetTxPowerSpectralDensity (uint16_t centerFrequency, uint16_t channelWidth, double txPowerW, WifiModulationClass modulationClass) const;
-
-  /**
-   * \param channelWidth the total channel width (MHz) used for the OFDMA transmission
+   * \param bandWidth the width (MHz) of the band used for the OFDMA transmission. Must be
+   *                  a multiple of 20 MHz
+   * \param guardBandwidth width of the guard band (MHz)
    * \param range the subcarrier range of the HE RU
+   * \param bandIndex the index (starting at 0) of the band within the operating channel
    * \return the converted subcarriers
    *
    * This is a helper function to convert HE RU subcarriers, which are relative to the center frequency subcarrier, to the indexes used by the Spectrum model.
    */
-  WifiSpectrumBand ConvertHeRuSubcarriers (uint16_t channelWidth, HeRu::SubcarrierRange range) const;
+  WifiSpectrumBand ConvertHeRuSubcarriers (uint16_t bandWidth, uint16_t guardBandwidth,
+                                           HeRu::SubcarrierRange range, uint8_t bandIndex = 0) const override;
 
   /**
    * Perform run-time spectrum model change
@@ -212,6 +192,12 @@
   Ptr<WifiSpectrumPhyInterface> m_wifiSpectrumPhyInterface; //!< Spectrum PHY interface
   Ptr<AntennaModel> m_antenna;                              //!< antenna model
   mutable Ptr<const SpectrumModel> m_rxSpectrumModel;       //!< receive spectrum model
+
+  /// Map a spectrum band associated with an RU to the RU specification
+  typedef std::map<WifiSpectrumBand, HeRu::RuSpec> RuBand;
+
+  std::map<uint16_t, RuBand> m_ruBands;  /**< For each channel width, store all the distinct spectrum
+                                              bands associated with every RU in a channel of that width */
   bool m_disableWifiReception;                              //!< forces this PHY to fail to sync on any signal
   TracedCallback<bool, uint32_t, double, Time> m_signalCb;  //!< Signal callback
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ssid.h ns-3.34/src/wifi/model/ssid.h
--- ns-3.33/src/wifi/model/ssid.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/ssid.h	2021-07-14 10:31:07.000000000 -0700
@@ -47,11 +47,11 @@
   Ssid (std::string s);
 
   // Implementations of pure virtual methods of WifiInformationElement
-  WifiInformationElementId ElementId () const;
-  uint8_t GetInformationFieldSize () const;
-  void SerializeInformationField (Buffer::Iterator start) const;
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
   uint8_t DeserializeInformationField (Buffer::Iterator start,
-                                       uint8_t length);
+                                       uint8_t length) override;
 
   /**
    * Check if the two SSIDs are equal.
